diff --git a/src/main/java/net/minecraft/client/entity/fx/EntitySlimeChunkFX.java b/src/main/java/net/minecraft/client/entity/fx/EntitySlimeChunkFX.java
index 23facc8c6..8f129d094 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntitySlimeChunkFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntitySlimeChunkFX.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.entity.fx;
 
 
+import net.minecraft.client.render.LightmapHelper;
+
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Item, Block, Tessellator,
 //            World
@@ -40,8 +42,13 @@ public class EntitySlimeChunkFX extends EntityFX
         float f11 = (float)((xo + (x - xo) * (double) partialTick) - lerpPosX);
         float f12 = (float)((yo + (y - yo) * (double) partialTick) - lerpPosY);
         float f13 = (float)((zo + (z - zo) * (double) partialTick) - lerpPosZ);
-        float f14 = getBrightness(partialTick);
-        t.setColorOpaque_F(f14 * particleRed, f14 * particleGreen, f14 * particleBlue);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        }else {
+        	brightness = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(brightness * particleRed, brightness * particleGreen, brightness * particleBlue);
         t.addVertexWithUV(f11 - rotationX * f10 - rotationYZ * f10, f12 - rotationXZ * f10, f13 - rotationZ * f10 - rotationXY * f10, f6, f9);
         t.addVertexWithUV((f11 - rotationX * f10) + rotationYZ * f10, f12 + rotationXZ * f10, (f13 - rotationZ * f10) + rotationXY * f10, f6, f8);
         t.addVertexWithUV(f11 + rotationX * f10 + rotationYZ * f10, f12 + rotationXZ * f10, f13 + rotationZ * f10 + rotationXY * f10, f7, f8);
diff --git a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
index eb73d7b8b..4eae7cab1 100644
--- a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
@@ -39,7 +39,7 @@ public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
         addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFootStepFX(mc.renderEngine, world, x, y, z));
         addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new EntitySplashFX(world1, d, d1, d2, d3, d4, d5));
         addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX, 2.5f));
-        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionX));
+        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityItemFX(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
         addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityDiggingFX(world, x, y, z,motionX,motionY,motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).setParticleColor((int) x, (int) y, (int) z));
         addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySnowShovelFX(world, x, y, z, motionX, motionY, motionX));
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 0c9c470cd..d9dc38c07 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -73,10 +73,16 @@ public class RenderBlocks
 	public void renderBlockFallingSand(Tessellator tessellator, BlockModel<Block> blockModel, Block block, WorldSource world, int x, int y, int z) {
 		final boolean lightmap = LightmapHelper.isLightmapEnabled();
 		
-		float sideBottom = 0.5f;
+		float sideBottom = 1.0f;
 		float sideTop = 1.0f;
-		float sideNorthSouth = 0.8f;
-		float sideEastWest = 0.6f;
+		float sideNorthSouth = 1.0f;
+		float sideEastWest = 1.0f;
+		if(enableDirectionalLight) {
+			sideBottom = 0.5f;
+			sideTop = 1.0f;
+			sideNorthSouth = 0.8f;
+			sideEastWest = 0.6f;
+		}
 		
 		tessellator.startDrawingQuads();
 		
@@ -380,7 +386,7 @@ public class RenderBlocks
             }
         }
 
-        if (overbright)
+        if (overbright || !enableDirectionalLight)
         {
             this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
             this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
@@ -998,6 +1004,7 @@ public class RenderBlocks
 
     public static final float[] SIDE_LIGHT_MULTIPLIER = {0.5f, 1.0f, 0.8f, 0.8f, 0.6f, 0.6f};
     public static final float FULL_CUBE_THRESHOLD = 1.0f / 16.0f;
+    public static boolean enableDirectionalLight = true;
     public boolean useInventoryTint;
     public int uvRotateEast;
     public int uvRotateWest;
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index 9a0295cdc..ab82b1af7 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -34,13 +34,13 @@ public class BlockColorTallGrass
 
             Season season = world.getSeasonManager().getCurrentSeason();
             if (season != null) {
-                boolean ishumid = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS || season == Seasons.OVERWORLD_FALL);
+                boolean ishumid = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS || season == Seasons.OVERWORLD_SPRING);
                 float progress = world.getSeasonManager().getSeasonProgress();
 
                 if (ishumid) {
-                    baseGrassColor = ColorizerGrass.getGrassColor(1.0, 1.0);
+                    baseGrassColor = ColorizerGrass.getGrassColor(0.95, 0.78);
                 } else {
-                    baseGrassColor = ColorizerGrass.getGrassColor(1.0, 0.0);
+                    baseGrassColor = ColorizerGrass.getGrassColor(0.95, 0.1);
                 }
                 baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
             }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index c3e09706a..879d1c04d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -176,7 +176,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelAxisAligned<>(Block.logCherry).withTextures("minecraft:block/log_cherry_top", "minecraft:block/log_cherry_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logEucalyptus).withTextures("minecraft:block/log_eucalyptus_top", "minecraft:block/log_eucalyptus_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logOakMossy).withTextures("minecraft:block/log_oak_mossy_top", "minecraft:block/log_oak_mossy_side"));
-        addDispatch(new BlockModelAxisAligned<>(Block.logBrazilwood).withTextures("minecraft:block/log_brazilwood_top", "minecraft:block/log_brazilwood_side"));
+        addDispatch(new BlockModelAxisAligned<>(Block.logThorn).withTextures("minecraft:block/log_brazilwood_top", "minecraft:block/log_brazilwood_side"));
 
         addDispatch(new BlockModelLeaves<>(Block.leavesOak, "minecraft:block/leaves_oak"));
         addDispatch(new BlockModelLeaves<>(Block.leavesOakRetro, "minecraft:block/leaves_oak_retro"));
@@ -197,6 +197,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingEucalyptus).withTextures("minecraft:block/sapling_eucalyptus"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingShrub).withTextures("minecraft:block/sapling_shrub"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingCacao).withTextures("minecraft:block/sapling_cacao"));
+        addDispatch(new BlockModelCrossedSquares<>(Block.saplingThorn).withTextures("minecraft:block/sapling_brazilwood"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.tallgrass).withTextures("minecraft:block/tallgrass"));
         addDispatch(new BlockModelCrossedSquares<>(Block.tallgrassFern).withTextures("minecraft:block/fern"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 569b7b043..224fb1453 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -32,10 +32,16 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T>{
     	
 		block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
 
-		float sideBottom = 0.5f;
+		float sideBottom = 1.0f;
 		float sideTop = 1.0f;
-		float sideNorthSouth = 0.8f;
-		float sideEastWest = 0.6f;
+		float sideNorthSouth = 1.0f;
+		float sideEastWest = 1.0f;
+		if(RenderBlocks.enableDirectionalLight) {
+			sideBottom = 0.5f;
+			sideTop = 1.0f;
+			sideNorthSouth = 0.8f;
+			sideEastWest = 0.6f;
+		}
 		
 		boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof BlockDoor;
 		boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof BlockDoor;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index de13c286e..13376b781 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -32,11 +33,17 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
         	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         }
         t.setColorOpaque_F(brightness, brightness, brightness);
-
-        float cBottom = 0.5F;
-        float cTop = 1.0F;
-        float cNorthSouth = 0.8F;
-        float cEastWest = 0.6F;
+        
+		float cBottom = 1.0f;
+		float cTop = 1.0f;
+		float cNorthSouth = 1.0f;
+		float cEastWest = 1.0f;
+		if(RenderBlocks.enableDirectionalLight) {
+			cBottom = 0.5f;
+			cTop = 1.0f;
+			cNorthSouth = 0.8f;
+			cEastWest = 0.6f;
+		}
 
         boolean connectNorth = block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
         boolean connectSouth = block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
@@ -153,14 +160,14 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
             double sidesMaxU;
             double sidesMaxV;
 
-            if (bottomTexIndex != null && !connectDownWest)
+            if (bottomTexIndex != null && !connectDownNorth)
             {
                 sidesMinU = fenceBottommostMinU;
                 sidesMinV = fenceBottommostMinV;
                 sidesMaxV = fenceBottommostMaxV;
                 sidesMaxU = fenceBottommostTex.getSubIconU(onePix * 8);
             }
-            else if (topTexIndex != null && !connectUpWest)
+            else if (topTexIndex != null && !connectUpNorth)
             {
                 sidesMinU = fenceTopmostMinU;
                 sidesMinV = fenceTopmostMinV;
@@ -201,14 +208,14 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
             double sidesMaxU;
             double sidesMaxV;
 
-            if (bottomTexIndex != null && !connectDownEast)
+            if (bottomTexIndex != null && !connectDownSouth)
             {
                 sidesMinU = fenceBottommostTex.getSubIconU(onePix * 8);
                 sidesMaxU = fenceBottommostTex.getIconUMax();
                 sidesMinV = fenceBottommostMinV;
                 sidesMaxV = fenceBottommostMaxV;
             }
-            else if (topTexIndex != null && !connectUpEast)
+            else if (topTexIndex != null && !connectUpSouth)
             {
                 sidesMinU = fenceTopmostTex.getSubIconU(onePix * 8);
                 sidesMaxU = fenceTopmostTex.getIconUMax();
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 936dd5b3b..3981a9fee 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -999,7 +999,7 @@ public class Block
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
     public static final Block logOakMossy = new BlockLog("log.oak.mossy", 285).withHardness(2.0F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
-    public static final Block logBrazilwood = new BlockLog("log.brazilwood", 286).withHardness(2.0F).withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block logThorn = new BlockLog("log.thorn", 286).withHardness(2.0F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
     public static final Block leavesOak = new BlockLeavesOak("leaves.oak", 290).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
@@ -1020,7 +1020,7 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
     public static final Block leavesCacao = new BlockLeavesCacao("leaves.cacao", 298).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
-    public static final Block leavesCaatinga = new BlockLeavesOak("leaves.caatinga", 299).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block leavesCaatinga = new BlockLeavesThorn("leaves.caatinga", 299).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
 
 
@@ -1040,6 +1040,8 @@ public class Block
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
     public static final Block saplingCacao = new BlockSaplingCacao("sapling.cacao", 317).withHardness(0.0F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+    public static final Block saplingThorn = new BlockSaplingThorn("sapling.thorn", 318).withHardness(0.0F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
 
     public static final Block tallgrass = new BlockTallGrass("tallgrass", 320).setKilledByWeather().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH);
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesThorn.java b/src/main/java/net/minecraft/core/block/BlockLeavesThorn.java
new file mode 100644
index 000000000..2b3167339
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesThorn.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class BlockLeavesThorn extends BlockLeavesBase
+{
+    public BlockLeavesThorn(String key, int id)
+    {
+        super(key, id, Material.leaves);
+    }
+    @Override
+    protected Block getSapling()
+    {
+        return Block.saplingThorn;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java b/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
new file mode 100644
index 000000000..f70b237be
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
@@ -0,0 +1,31 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureThornTree;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Random;
+
+public class BlockSaplingThorn extends BlockSaplingBase
+{
+
+    public BlockSaplingThorn(String key, int id)
+    {
+        super(key, id);
+    }
+
+
+    @Override
+    public void growTree(World world, int x, int y, int z, Random random)
+    {
+        WorldFeature treeFeature = null;
+
+        world.setBlock(x, y, z, 0);
+        treeFeature = new WorldFeatureThornTree(1, Block.logThorn.id, 0, Block.leavesCaatinga.id, 0);
+
+        if(!treeFeature.generate(world, random, x, y, z))
+        {
+            world.setBlock(x, y, z, id);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java b/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
index e1b74219a..79afce5ee 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
@@ -31,6 +31,7 @@ public class EntitySlime extends EntityLiving
         slimeJumpDelay = 20;
         scoreValue = 100;
         this.hasSlimeSplit = false;
+        mobDrops.add(new WeightedRandomLootObject(Item.slimeball.getDefaultStack(), 0, 2));
     }
     public EntitySlime(World world, boolean isSplit)
     {
@@ -41,6 +42,7 @@ public class EntitySlime extends EntityLiving
         slimeJumpDelay = 20;
         scoreValue = 100;
         this.hasSlimeSplit = isSplit;
+        mobDrops.add(new WeightedRandomLootObject(Item.slimeball.getDefaultStack(), 0, 2));
     }
 
     @Override
@@ -48,7 +50,6 @@ public class EntitySlime extends EntityLiving
     {
         super.init();
         entityData.define(16, (byte) 1);
-        mobDrops.add(new WeightedRandomLootObject(Item.slimeball.getDefaultStack(), 0, 2));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 70e0fc930..3b5c1673f 100644
--- a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Side;
@@ -39,6 +40,9 @@ public class ItemWandSpawner extends Item{
             if (entity != null){
                 entity.setPos(blockX + side.getOffsetX() + 0.5f, blockY + side.getOffsetY(), blockZ + side.getOffsetZ() + 0.5f);
                 entity.spawnInit();
+                if (itemstack.hasCustomName() && entity instanceof EntityLiving){
+                    ((EntityLiving)entity).setNickname(itemstack.getCustomName());
+                }
                 world.entityJoinedWorld(entity);
             }
         }
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
index fcce4cc74..83f841654 100644
--- a/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeCaatinga.java
@@ -28,17 +28,8 @@ public class BiomeCaatinga extends Biome
         {
             return new WorldFeatureTreeShrub(Block.leavesCaatinga.id, Block.logOak.id);
         } else
-        if(random.nextInt(3) == 0)
         {
-            return new WorldFeatureTree(Block.leavesCaatinga.id, Block.logOak.id, 6);
-
-        } else
-        if(random.nextInt(3) == 0)
-        {
-            return new WorldFeatureTreeFancy(Block.leavesCaatinga.id, Block.logOak.id);
-        } else
-        {
-            return new WorldFeatureTreeCaatinga(Block.leavesCaatinga.id, Block.logBrazilwood.id);
+            return new WorldFeatureThornTree(1, Block.logThorn.id, 0, Block.leavesCaatinga.id, 0);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java b/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java
index ebea517eb..ecf762fb2 100644
--- a/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeDryForest.java
@@ -22,7 +22,7 @@ public class BiomeDryForest extends BiomeForest
 
         if(random.nextInt(3) == 0)
         {
-            return new WorldFeatureTreeShrub(Block.leavesOak.id, Block.logOak.id);
+            return new WorldFeatureTreeShrub(Block.leavesShrub.id, Block.logOak.id);
         } else
         {
             return new WorldFeatureTree(Block.leavesOak.id, Block.logOak.id, 4);
diff --git a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index f61fcaf5f..b836ee2f6 100644
--- a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -29,7 +29,7 @@ public final class BiomeProviderOverworld
     private double humidityXScale = 0.025;
     private double humidityZScale = 0.025;
     private double humidityExponent = 0.3;
-    private double humidityFuzzPercentage = 0.002;
+    private double humidityFuzzPercentage = 0.01;
 
     private double varietyXScale = 0.25;
     private double varietyZScale = 0.25;
@@ -38,7 +38,7 @@ public final class BiomeProviderOverworld
 
     private double fuzzinessXScale = 0.25;
     private double fuzzinessZScale = 0.25;
-    private double fuzzinessExponent = 0.5;
+    private double fuzzinessExponent = 1.0;
 
     private final WorldType worldType;
 
@@ -365,7 +365,7 @@ public final class BiomeProviderOverworld
                 new BiomeRange(0.75, 0.95, 0.2, 0.4, 0.0, 1.0, 0.95, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_DESERT,
-                new BiomeRange(0.95, 1.0, 0.0, 0.2, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.95, 1.0, 0.0, 0.1, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_OUTBACK,
                 new BiomeRange(0.75, 0.95, 0.0, 0.1, 0.0, 1.0, 0.15, 1.0)
@@ -388,10 +388,10 @@ public final class BiomeProviderOverworld
                 new BiomeRange(0.75, 0.95, 0.2, 0.4, 0.0, 1.0, 0.0, 0.95)
         );
         brm.addRange(Biomes.OVERWORLD_CAATINGA,
-                new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.0, 0.75)
+                new BiomeRange(0.95, 1.0, 0.1, 0.4, 0.0, 1.0, 0.0, 0.75)
         );
         brm.addRange(Biomes.OVERWORLD_CAATINGA_PLAINS,
-                new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.75, 1.0)
+                new BiomeRange(0.95, 1.0, 0.1, 0.4, 0.0, 1.0, 0.75, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_CAATINGA,
                 new BiomeRange(0.95, 1.0, 0.2, 0.4, 0.0, 1.0, 0.0, 1.0)
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index d1a857c08..2ebc40452 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -261,9 +261,6 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_CAATINGA) {
             treeDensity += k4 + 10;
         }
-        if (biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
-            treeDensity -= 10;
-        }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             treeDensity += k4 + 4;
         }
@@ -426,26 +423,17 @@ public class ChunkDecoratorOverworld
             byte1 = 10;
         }
         if (biome == Biomes.OVERWORLD_CAATINGA) {
-            byte1 = 3;
-        }
-        if (biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
-            byte1 = 1;
+            byte1 = 5;
         }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             byte1 = 4;
         }
-        if (biome == Biomes.OVERWORLD_SHRUBLAND) {
-            byte1 = 2;
-        }
         if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY) {
             byte1 = 25;
         }
         if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
             byte1 = 2;
         }
-        if (biome == Biomes.OVERWORLD_FOREST_DRY) {
-            byte1 = 3;
-        }
         for (int l14 = 0; l14 < byte1; l14++) {
             int type = Block.tallgrass.id;
             if ((biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_TAIGA) && rand.nextInt(3) != 0) {
@@ -473,6 +461,9 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_DESERT) {
             byte1 = 2;
         }
+        if (biome == Biomes.OVERWORLD_CAATINGA_PLAINS || biome == Biomes.OVERWORLD_CAATINGA) {
+            byte1 = 1;
+        }
         for (int i15 = 0; i15 < byte1; i15++) {
             int i17 = x + rand.nextInt(16) + 8;
             int i20 = minY + rand.nextInt(rangeY);
@@ -527,7 +518,7 @@ public class ChunkDecoratorOverworld
         }
         if(biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_CAATINGA_PLAINS)
         {
-            k16 += 3;
+            k16 += 10;
         }
         for(int k18 = 0; k18 < k16; k18++)
         {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureThornTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureThornTree.java
new file mode 100644
index 000000000..960c4e06e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureThornTree.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.world.generate.feature.tree;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.tree.spooner.WorldFeatureSpoonerTreeProcedural;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class WorldFeatureThornTree extends WorldFeatureSpoonerTreeProcedural {
+    public WorldFeatureThornTree(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(height, trunkId, trunkData, leavesId, leavesData);
+    }
+
+    @Override
+    protected void prepare(World world) {
+        this.height = height + random.nextInt(3);
+        this.foliageShape = new double[] { 4.5, 3.5, 2.5, 1.5 };
+        this.branchSlope = 1;
+        this.trunkRadius = 1;
+        this.trunkHeight = this.height * 0.9;
+        this.branchDensity = BRANCH_DENSITY / FOLIAGE_DENSITY;
+        int axis = random.nextInt(2);
+        List<int[]> foliageCoords = new ArrayList<>();
+        int yStart = this.pos[1]+1;
+
+        int x = this.pos[0];
+        int y = this.pos[1] + this.height + random.nextInt(3)+3;
+        int z = this.pos[2];
+        int x1 = this.pos[0];
+        int z1 = this.pos[2];
+        int y1 = this.pos[1] + this.height + random.nextInt(3)+3;
+
+        Double shapefac = shapeFunc(y - yStart);
+
+        double r = (Math.sqrt(random.nextDouble() * 2.0) + 0.125) * shapefac;
+
+        double theta = random.nextDouble() * 2 * Math.PI;
+
+        if(axis == 1) {
+            x += (int) (r * Math.sin(theta));
+            x1 -= (int) (r * Math.sin(theta));
+        } else {
+            z += (int) (r * Math.sin(theta));
+            z1 -= (int) (r * Math.sin(theta));
+        }
+        foliageCoords.add(new int[] { x, y, z });
+        foliageCoords.add(new int[] { x1, y1, z1 });
+
+
+        this.foliageCoords = foliageCoords;
+    }
+
+    @Override
+    protected void makeBranches(World world) {
+        int[] treePosition = this.pos;
+        int topY = treePosition[1] + (int)(this.trunkHeight + 1.5);
+
+        for (int[] coord: foliageCoords) {
+            double dist = Math.sqrt(Math.pow(coord[0] - treePosition[0], 2) + Math.pow(coord[2] - treePosition[2], 2));
+
+            int posY = coord[1];
+            double slope = this.branchSlope + (0.5 - random.nextDouble()) * 0.16;
+            double branchY;
+            if (coord[1] - dist * slope > topY) {
+
+                branchY = topY;
+            } else {
+                branchY = posY - dist * slope;
+            }
+            int[] startCoord = new int[] { treePosition[0], (int) branchY, treePosition[2]};
+            taperedLimb(startCoord, coord, 1.0, 1.0, world);
+        }
+    }
+
+    @Override
+    protected Double shapeFunc(int y) {
+        return (double) (this.height + 3) * 0.5;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index b3fe1a229..95f8d457d 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -111,7 +111,7 @@ public abstract class WorldFeatureSpoonerTree
         this.random = random;
         this.pos = new int[] { x, y, z };
 
-        if (y < 1 || y > height + world.getHeightBlocks()) {
+        if (y < 1 || y + height > world.getHeightBlocks()) {
             return false;
         }
         if (!canGenerateTree(world)) {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
index 1b493378d..5fc014537 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
@@ -129,6 +129,8 @@ public abstract class WorldFeatureSpoonerTreeProcedural
     protected void makeFoliage(World world) {
         List<int[]> foliageCoords = this.foliageCoords;
 
+        if(this.foliageCoords == null)
+            return;
         for (int[] coord: foliageCoords) {
             foliageCluster(coord, world);
         }
